##
## Vers. 0.11, 2003-03-10
## Anpassung an das Modul re (statt regex)
## siehe regexdem.py
##

from Tkinter import *
import re
import sys


root = None
flags = None



def die():
    root.destroy()
    sys.exit()
    
class RegexDemo:
    
    def __init__(self, master):
        self.master = master
        self.topframe = Frame(self.master)
        self.topframe.pack(fill=X)
        self.promptdisplay = Label(self.topframe,text=u"Gib ein Textmuster ein:")
##        self.promptdisplay = Label(self.topframe,
##                                   text=u"Gib einen regul\xe4ren Ausdruck ein:")
        self.promptdisplay.pack(side=LEFT)
        self.statusdisplay = Label(self.topframe,
                                   text="",
                                   anchor=W)
        self.statusdisplay.pack(side=LEFT, fill=X)
        self.regexdisplay = Entry(self.master)
        self.regexdisplay.pack(fill=X)
        self.regexdisplay.focus_set()
        self.labeldisplay = Label(self.master, anchor=W, text="Gib den Beispiel-Text ein:")        
##        self.labeldisplay = Label(self.master, anchor=W,
##                                  text="Gib eine Zeichenkette ein:")        
        self.labeldisplay.pack(fill=X)
        self.labeldisplay.pack(fill=X)
        self.stringdisplay = Text(self.master,
                                  width=60,
                                  height=4)
        self.stringdisplay.pack(fill=BOTH, expand=1)
        self.stringdisplay.tag_configure("hit",
                                         background="yellow")
        self.addoptions()
        self.regexdisplay.bind('<Key>', self.recompile)
        self.stringdisplay.bind('<Key>', self.reevaluate)
        self.compiled = None
        self.recompile()
        btags = self.regexdisplay.bindtags()
        self.regexdisplay.bindtags(btags[1:] + btags[:1])
        btags = self.stringdisplay.bindtags()
        self.stringdisplay.bindtags(btags[1:] + btags[:1])

    def addoptions(self):
        self.frames = []
        self.boxes = []
        self.vars = []
        for name in ('IGNORECASE',
                     'LOCALE',
                     'MULTILINE',
                     'DOTALL',
                     'UNICODE',
                     'VERBOSE'):
            if len(self.boxes) % 6 == 0:
                frame = Frame(self.master)
                frame.pack(fill=X)
                self.frames.append(frame)
            var = IntVar()
            box = Checkbutton(frame,
                              variable=var,
                              text=name,
                              offvalue=0,                              
                              command=self.newsyntax)
            box.pack(side=LEFT)
            self.boxes.append(box)
            self.vars.append(var)
    
    def newsyntax(self):
        global flags
        flag = ''
        re_flag = ['re.IGNORECASE','re.LOCALE','re.MULTILINE','re.DOTALL','re.UNICODE','re.VERBOSE']
        i = 0
        for var in self.vars:
            if var.get():
                if flag == '':
                    flag = re_flag[i]
                else:    
                    flag = flag + ' | ' + re_flag[i] #
            i = i + 1    
        ##############    Hier flag umwandeln!!!!!
        if flag != '':    
            flags = eval(flag)
        else:  # flag == '' !!!
            flags = None
        self.recompile()
    
    def recompile(self, Event = None):
        global flags
        debug = 0
        try:
            if flags == None:
                self.compiled = re.compile(self.regexdisplay.get() )
                self.statusdisplay.config(text="")
                if debug:
                    print ('flags == None ')
            else: ## flags ungleich None!
                self.compiled = re.compile(self.regexdisplay.get(),flags )
                self.statusdisplay.config(text="")
                if debug:
                    print flags

        except re.error, msg:
            self.compiled = None
            self.statusdisplay.config(text="re.error: %s" %
                                      str(msg))
        self.reevaluate()
    
    def reevaluate(self, event=None):
        try:
            self.stringdisplay.tag_remove("hit", "1.0", END)
        except TclError:
            pass
        if not self.compiled:
            return
        text = self.stringdisplay.get("1.0", END)
        match_object = self.compiled.search(text)
        if match_object == None:
            self.statusdisplay.config(text=" NO MATCH! ")
        else:
            self.statusdisplay.config(text="")
            first, last = match_object.span()
            ##alternativ:
            ##first = match_object.start()
            ##last = match_object.end()
            if last == first:
                last = first+1
                self.stringdisplay.tag_configure("hit",
                                                 background="red")
            else:
                self.stringdisplay.tag_configure("hit",
                                                 background="yellow")
            pfirst = "1.0 + %d chars" % first
            plast = "1.0 + %d chars" % last
            self.stringdisplay.tag_add("hit", pfirst, plast)
            self.stringdisplay.yview_pickplace(pfirst)



if __name__ == '__main__':
    root = Tk()
    root.title(u'regDemo: regul\xe4re Ausdr\xfccke in Python!')
    demo = RegexDemo(root)
    root.protocol('WM_DELETE_WINDOW', die )
    root.mainloop()
